<?php
/*
   TMOS plugin for Aseco v1
   Copyright (c) 2007 Alexander Domnin

   This program is licenced under the Creative Commons Attribution-NonCommercial-NoDerivs 2.5
   To view a copy of this licence, visit http://creativecommons.org/licenses/by-nc-nd/2.5/

   This program is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY;
   without even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
*/

class TTMOS {
   var $inf;
   var $cfg;
   var $mysql_link;

   function TTMOS() {
      $this->inf = array();
      $this->cfg = array();
      $this->mysql_link = null;
   }

   function init($acfg) {
      $this->cfg = $acfg;
      $this->inf['ver'] = $this->cfg['ver'];
      $this->inf['cfg'] = $this->cfg_check();
      if (!$this->inf['cfg']) {
         $this->inf['db'] = false;
         $this->inf['schema'] = false;
         $this->inf['srv'] = false;
      }
      else {
         $this->inf['db'] = $this->db_open();
         if ($this->inf['db']) {
            $this->inf['schema'] = $this->db_check();
            if ($this->inf['schema'])
               $this->inf['srv'] = $this->srv_check();
            else
               $this->inf['srv'] = false;
         }
         else {
            $this->inf['schema'] = false;
            $this->inf['srv'] = false;
         }
      }
      if ($this->inf['cfg'] && $this->inf['db'] && $this->inf['schema'] && $this->inf['srv'])
         $this->inf['enable'] = true;
      else
         $this->inf['enable'] = false;
      return $this->inf;
   }

   // is this really need, looks like bug ? :)
   function cfg_check() {
      if (isset($this->cfg['dbhost']) &&
          isset($this->cfg['dbname']) &&
          isset($this->cfg['dblogin']) &&
          isset($this->cfg['dbpassword']) &&
          isset($this->cfg['dbserverid']) &&
          isset($this->cfg['write_to_chat']) &&
          isset($this->cfg['tt']) &&
          isset($this->cfg['tt_author']) &&
          isset($this->cfg['tt_gold']) &&
          isset($this->cfg['tt_silver']) &&
          isset($this->cfg['tt_bronze']) &&
          isset($this->cfg['tt_player_str']) &&
          isset($this->cfg['tt_player_nf']) &&
          isset($this->cfg['lu']) &&
          isset($this->cfg['t10']) &&
          isset($this->cfg['t10_str']) &&
          isset($this->cfg['t10_player']) &&
          isset($this->cfg['t10_player_str']) &&
          isset($this->cfg['t10_player_nf']) &&
          isset($this->cfg['stats']) &&
          isset($this->cfg['stats_rank']) &&
          isset($this->cfg['stats_score']) &&
          isset($this->cfg['stats_medals']) &&
          isset($this->cfg['stats_tf']) &&
          isset($this->cfg['stats_first']) &&
          isset($this->cfg['recs']) &&
          isset($this->cfg['recs_str']) &&
          isset($this->cfg['recs_player']) &&
          isset($this->cfg['recs_player_str']) &&
          isset($this->cfg['recs_player_nf']) &&
          isset($this->cfg['teams']) &&
          isset($this->cfg['teams_str']) &&
          isset($this->cfg['srv']) &&
          isset($this->cfg['srv_tp']) &&
          isset($this->cfg['srv_tt']) &&
          isset($this->cfg['srv_ta']) &&
          isset($this->cfg['srv_tc']) &&
          isset($this->cfg['time']) &&
          isset($this->cfg['t10_nf']) &&
          isset($this->cfg['stats_nf']) &&
          isset($this->cfg['recs_nf']) &&
          isset($this->cfg['err_disabled']) &&
          isset($this->cfg['err_parameter']) &&
          isset($this->cfg['help']) &&
          isset($this->cfg['help_c']) &&
          isset($this->cfg['help_tt']) &&
          isset($this->cfg['help_top10']) &&
          isset($this->cfg['help_stats']) &&
          isset($this->cfg['help_recs']) &&
          isset($this->cfg['help_teams']) &&
          isset($this->cfg['help_srv']) &&
          isset($this->cfg['help_curr']) &&
          isset($this->cfg['help_time']))
         return true;
      else
         return false;
   }

   function get_id($str) {
      return substr(md5($str), 0, 11); // PS_ID_LENGTH
   }

   function name_clear($name) {
      $name = preg_replace('/(\$\$)/u', "\x01", $name);
      $patterns = array ('/(\$o)/iu', '/(\$s)/iu', '/(\$i)/iu', '/(\$n)/iu', '/(\$w)/iu', '/(\$g)/iu', '/(\$z)/iu', '/(\$m)/iu', '/(\$...)/iu', '/(^\s+)/u', '/(\s+$)/u');
      $replace = array ('', '', '', '', '', '', '', '', '', '', '');
      $name = preg_replace($patterns, $replace, $name);
      return preg_replace("/\x01/u", '$', $name);
   }

   function get_player_account($login) {
      if (preg_match("/(.+)\/\d+\.\d+\.\d+\.\d+:\d+/u", $login, $matches))
         return $this->name_clear($matches[1]);
      else
         return $login;
   }

   function time_cut($timestr) {
      if (substr($timestr, 0, 3) == "00:")
         return substr($timestr, 3);
      else
         return $timestr;
   }

   function add_spaces($str, $len_max) {
      $result = $str;
      $len_curr = strlen($str);
      if ($len_curr < $len_max) {
         for ($i = 0; $i < $len_max-$len_curr; $i++)
            $result = "  ".$result;
      }
      return $result;
   }

   function get_time() {
      return date("j-m-Y H:i", time());
   }

   function get_lu_time() {
      $query_result = $this->db_query("select last_update from tmos_servers where serverid={$this->cfg['dbserverid']}");
      return date("j-m-Y H:i", $query_result[0]['last_update']);
   }

   function get_player_stats($login, $stats) {
      $playerid = $this->get_id($this->get_player_account($login));
      $stats == "a" ? $statsid = "" : $statsid = "_c";
      $query_result = $this->db_query("select player, am$statsid as am, gm$statsid as gm, sm$statsid as sm, bm$statsid as bm, round(score$statsid, 2) as score from tmos_players where serverid={$this->cfg['dbserverid']} and playerid='$playerid'");
      if ($query_result['count'] == 0)
         return -1;
      else {
         $tmp = $this->db_query("select count(playerid) as rk from tmos_players where serverid={$this->cfg['dbserverid']} and score$statsid>{$query_result[0]['score']}");
         $query_result[0]['rank'] = $tmp[0]['rk']+1;
         $tmp = $this->db_query("select count(trackid) as ct from tmos_view where serverid={$this->cfg['dbserverid']} and stats='$stats' and playerid='$playerid'");
         $query_result[0]['tracksfinished'] = $tmp[0]['ct'];
         $tmp = $this->db_query("select count(trackid) as cf from tmos_view where serverid={$this->cfg['dbserverid']} and stats='$stats' and playerid='$playerid' and rank=1");
         $query_result[0]['first'] = $tmp[0]['cf'];
         return $query_result[0];
      }
   }

   /* fghfgh */
   function get_player_stats_format($login, $stats) {
      $result = $this->get_player_stats($login, $stats);
      return $result;
   }

   /* [server],[totalplayers],[totaltracks],[totalawards],[totalteams]*/
   function get_srv_stats_format($stats) {
      $stats == "a" ? $statsid = "" : $statsid = "_c";
      $query_result = $this->db_query("select server from tmos_servers where serverid={$this->cfg['dbserverid']}");
      $result['server'] = $query_result[0]['server'];
      $query_result = $this->db_query("select count(*) as tp, sum(am$statsid+gm$statsid+sm$statsid+bm$statsid) as ta from tmos_players where serverid={$this->cfg['dbserverid']}");
      $result['totalplayers'] = $query_result[0]['tp'];
      $query_result[0]['ta'] == "" ? $result['totalawards'] = 0 : $result['totalawards'] = $query_result[0]['ta'];
      $query_result = $this->db_query("select count(distinct trackid) as tt from tmos_results where serverid={$this->cfg['dbserverid']}");
      $result['totaltracks'] = $query_result[0]['tt'];
      $query_result = $this->db_query("select count(*) as tc from tmos_clans where serverid={$this->cfg['dbserverid']}");
      $result['totalteams'] = $query_result[0]['tc'];
      return $result;
   }

   function get_top10($stats) {
      $stats == "a" ? $statsid = "" : $statsid = "_c";
      $query_result = $this->db_query("select player, round(score$statsid, 2) as score from tmos_players where serverid={$this->cfg['dbserverid']} order by score$statsid desc limit 10");
      if ($query_result['count'] == 0)
         return -1;
      else
         return $query_result;
   }

   /* [count],[0],[1], ... ,[x]->([rank],[player],[score]) */
   function get_top10_format($login, $stats) {
      $result = $this->get_top10($stats);
      if ($result !== -1) {
         $result['x'] = $this->get_player_stats($login, $stats);
         if ($result['x'] !== -1 && $result['x']['rank'] > $result['count']) $len_rank_max = strlen($result['x']['rank']);
         else if ($result['count'] > 9) $len_rank_max = 2;
         else $len_rank_max = 1;
         $len_score_max = strlen($result[0]['score']);
         for ($i = 0; $i < $result['count']; $i++) {
            $result[$i]['rank'] = $this->add_spaces($i+1, $len_rank_max);
            $result[$i]['score'] = $this->add_spaces($result[$i]['score'], $len_score_max);
         }
         if ($result['x'] !== -1) {
            $result['x']['rank'] = $this->add_spaces($result['x']['rank'], $len_rank_max);
            $result['x']['score'] = $this->add_spaces($result['x']['score'], $len_score_max);
         }
      }
      return $result;
   }

   function get_ptt($login, $trackuid, $stats) {
      $playerid =  $this->get_id($this->get_player_account($login));
      $trackid = $this->get_id($trackuid);
      $query_result = $this->db_query("select p.player, v.rank, v.bestresult from tmos_players p, tmos_view v where v.serverid={$this->cfg['dbserverid']} and v.stats='$stats' and v.trackid='$trackid' and v.playerid='$playerid' and v.playerid=p.playerid");
      if ($query_result['count'] == 0)
         return -1;
      else
         return $query_result[0];
   }

   /* [player],[rank],[bestresult] */
   function get_ptt_format($login, $trackuid, $stats) {
      $result = $this->get_ptt($login, $trackuid, $stats);
      if ($result !== -1) {
         $result['bestresult'] = $this->time_cut($result['bestresult']);
      }
      return $result;
   }

   function get_recs($trackuid, $stats) {
      $trackid = $this->get_id($trackuid);
      $query_result = $this->db_query("select p.player, v.rank, v.bestresult from tmos_players p, tmos_view v where v.serverid={$this->cfg['dbserverid']} and v.stats='$stats' and v.trackid='$trackid' and v.rank<11 and p.playerid=v.playerid order by v.rank limit 10");
      if ($query_result['count'] == 0)
         return -1;
      else
         return $query_result;
   }

   /* [count],[0],[1], ... ,[x]->([rank],[player],[bestresult]) */
   function get_recs_format($login, $trackuid, $stats) {
      $result = $this->get_recs($trackuid, $stats);
      if ($result !== -1) {
         $result['x'] = $this->get_ptt($login, $trackuid, $stats);
         if ($result['x'] !== -1 && $result['x']['rank'] > $result['count']) $len_rank_max = strlen($result['x']['rank']);
         else if ($result['count'] > 9) $len_rank_max = 2;
         else $len_rank_max = 1;
         for ($i = 0; $i < $result['count']; $i++) {
            $result[$i]['rank'] = $this->add_spaces($result[$i]['rank'], $len_rank_max);
            $result[$i]['bestresult'] = $this->time_cut($result[$i]['bestresult']);
         }
         if ($result['x'] !== -1) {
            $result['x']['rank'] = $this->add_spaces($result['x']['rank'], $len_rank_max);
            $result['x']['bestresult'] = $this->time_cut($result['x']['bestresult']);
         }
      }
      return $result;
   }

   function get_teams($stats) {
      $stats == "a" ? $statsid = "" : $statsid = "_c";
      $query_result = $this->db_query("select clanc, round(score$statsid, 2) as score, tm from tmos_clans where serverid={$this->cfg['dbserverid']} order by score$statsid desc limit 10");
      if ($query_result['count'] == 0)
         return -1;
      else
         return $query_result;
   }

   function get_teams_format($stats) {
      $result = $this->get_teams($stats);
      if ($result !== -1) {
         if ($result['count'] > 9) $len_rank_max = 2;
         else $len_rank_max = 1;
         $len_score_max = strlen($result[0]['score']);
         $len_tm_max = 2;
         for ($i = 0; $i < $result['count']; $i++) {
            $result[$i]['rank'] = $this->add_spaces($i+1, $len_rank_max);
            $result[$i]['score'] = $this->add_spaces($result[$i]['score'], $len_score_max);
            $result[$i]['tm'] = $this->add_spaces($result[$i]['tm'], $len_tm_max);
         }
      }
      return $result;
   }

   function db_open() {
      $this->mysql_link = @mysql_connect($this->cfg['dbhost'], $this->cfg['dblogin'], $this->cfg['dbpassword']);
      if (!$this->mysql_link) {
         $result = false;
         $this->mysql_link = null;
      }
      else if (!@mysql_select_db($this->cfg['dbname'], $this->mysql_link)) {
         @mysql_close($this->mysql_link);
         $result = false;
         $this->mysql_link = null;
      }
      else {
         @mysql_query("/*!40101 SET NAMES 'utf8' */", $this->mysql_link);
         $result = true;
      }
      return $result;
   }

   function db_query($sql) {
      $query_result = mysql_query($sql, $this->mysql_link) or die("TTMOS: ".mysql_error());
      $result['count'] = 0;
      while($curr_str = mysql_fetch_array($query_result, MYSQL_ASSOC)) {
         $result[$result['count']] = $curr_str;
         $result['count'] += 1;
      }
      mysql_free_result($query_result);
      return $result;
   }

   function db_close() {
      if ($this->mysql_link != null)
         @mysql_close($this->mysql_link);
   }

   function db_check() {
      $db_schema = array(
            "tmos_servers"=>array("serverid"=>1, "server"=>1, "serverc"=>1, "ip"=>1, "game"=>1,
                                  "login"=>1, "password"=>1, "tracks"=>"1", "logfiles"=>"1", "last_update"=>"1"),
            "tmos_players"=>array("serverid"=>1, "playerid"=>1, "account"=>1, "player"=>1, "playerc"=>1,
                                  "aliases"=>1, "lastonline"=>1, "am"=>1, "gm"=>1, "sm"=>1, "bm"=>1, "score"=>1,
                                  "am_c"=>1, "gm_c"=>1, "sm_c"=>1, "bm_c"=>1, "score_c"=>1),
            "tmos_tracks" =>array("serverid"=>1, "trackid"=>1, "uid"=>1, "track"=>1, "trackc"=>1,
                                  "author"=>1, "envir"=>1, "mood"=>1, "type"=>1, "nblaps"=>1, "price"=>1,
                                  "bronze"=>1, "silver"=>1, "gold"=>1, "authortime"=>1, "authorscore"=>1,
                                  "relpath"=>1),
            "tmos_results"=>array("serverid"=>1, "resultid"=>1, "trackid"=>1, "playerid"=>1, "result"=>1, "ts"=>1),
            "tmos_clans"=>array("serverid"=>1, "clanid"=>1, "clanc"=>1, "description"=>1, "members"=>1, "score"=>1, "score_c"=>1, "tm"=>1),
            "tmos_view"=>array("serverid"=>1, "stats"=>1, "trackid"=>1, "playerid"=>1, "bestresult"=>1, "ts"=>1, "award"=>1, "rank"=>1, "totalresults"=>1)
      );

      $db_schema_exists = array();
      $tables = mysql_list_tables($this->cfg['dbname'], $this->mysql_link);
      while ($curr_table = mysql_fetch_row($tables)) {
         $fields = mysql_list_fields($this->cfg['dbname'], $curr_table[0], $this->mysql_link);
         $columns = mysql_num_fields($fields);
         for ($i = 0; $i < $columns; $i++) {
            $db_schema_exists[$curr_table[0]][mysql_field_name($fields, $i)] = "1";
         }
         mysql_free_result($fields);
      }
      mysql_free_result($tables);

      $result = true;
      foreach ($db_schema as $curr_table=>$fields) {
         if (!isset($db_schema_exists[$curr_table])) {
            $result = false;
            break;
         }
         else {
            foreach ($fields as $curr_field=>$tmp)
               if (!isset($db_schema_exists[$curr_table][$curr_field])) {
                  $result = false;
                  break;
               }
         }
      }
      return $result;
   }

   function srv_check() {
      $query_result = $this->db_query("select * from tmos_servers where serverid={$this->cfg['dbserverid']}");
      if ($query_result['count'] == 0)
         return false;
      else
         return true;
   }
}

?>