<?php
/*
   TMOS plugin for Aseco v1
   Copyright (c) 2007 Alexander Domnin

   This program is licenced under the Creative Commons Attribution-NonCommercial-NoDerivs 2.5
   To view a copy of this licence, visit http://creativecommons.org/licenses/by-nc-nd/2.5/

   This program is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY;
   without even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
*/


Aseco::registerEvent("onStartup", "init_tmos");
Aseco::addChatCommand("tmos", "displays TMOS in the game (for more: /tmos help)");

function init_tmos(&$aseco, &$command) {

   require_once("includes/types.tmos.inc.php");

   // cfg
   $cfg['ver'] = "v0.62";
   if ($res = $aseco->xml_parser->parseXml("tmos.xml")) {
      $cfg['dbhost']          = $res['SETTINGS']['TMOS_DB'][0]['DBHOST'][0];
      $cfg['dbname']          = $res['SETTINGS']['TMOS_DB'][0]['DBNAME'][0];
      $cfg['dblogin']         = $res['SETTINGS']['TMOS_DB'][0]['DBLOGIN'][0];
      $cfg['dbpassword']      = $res['SETTINGS']['TMOS_DB'][0]['DBPASSWORD'][0];
      $cfg['dbserverid']      = $res['SETTINGS']['TMOS_DB'][0]['DBSERVERID'][0];
      $cfg['write_to_chat']   = strtoupper($res['SETTINGS']['TMOS_IT'][0]['WRITE_TO_CHAT'][0]) == "TRUE" ? true : false;
      $cfg['tt']              = $res['SETTINGS']['TMOS_IT'][0]['TT'][0];
      $cfg['tt_author']       = $res['SETTINGS']['TMOS_IT'][0]['TT_AUTHOR'][0];
      $cfg['tt_gold']         = $res['SETTINGS']['TMOS_IT'][0]['TT_GOLD'][0];
      $cfg['tt_silver']       = $res['SETTINGS']['TMOS_IT'][0]['TT_SILVER'][0];
      $cfg['tt_bronze']       = $res['SETTINGS']['TMOS_IT'][0]['TT_BRONZE'][0];
      $cfg['tt_player_str']   = $res['SETTINGS']['TMOS_IT'][0]['TT_PLAYER_STR'][0];
      $cfg['tt_player_nf']    = $res['SETTINGS']['TMOS_IT'][0]['TT_PLAYER_NF'][0];
      $cfg['lu']              = $res['SETTINGS']['TMOS_IT'][0]['LU'][0];
      $cfg['t10']             = $res['SETTINGS']['TMOS_IT'][0]['TOP10'][0];
      $cfg['t10_str']         = $res['SETTINGS']['TMOS_IT'][0]['TOP10_STR'][0];
      $cfg['t10_nf']          = $res['SETTINGS']['TMOS_IT'][0]['TOP10_NF'][0];
      $cfg['t10_player']      = $res['SETTINGS']['TMOS_IT'][0]['TOP10_PLAYER'][0];
      $cfg['t10_player_str']  = $res['SETTINGS']['TMOS_IT'][0]['TOP10_PLAYER_STR'][0];
      $cfg['t10_player_nf']   = $res['SETTINGS']['TMOS_IT'][0]['TOP10_PLAYER_NF'][0];
      $cfg['stats']           = $res['SETTINGS']['TMOS_IT'][0]['STATS'][0];
      $cfg['stats_nf']        = $res['SETTINGS']['TMOS_IT'][0]['STATS_NF'][0];
      $cfg['stats_rank']      = $res['SETTINGS']['TMOS_IT'][0]['STATS_RANK'][0];
      $cfg['stats_score']     = $res['SETTINGS']['TMOS_IT'][0]['STATS_SCORE'][0];
      $cfg['stats_medals']    = $res['SETTINGS']['TMOS_IT'][0]['STATS_MEDALS'][0];
      $cfg['stats_tf']        = $res['SETTINGS']['TMOS_IT'][0]['STATS_TF'][0];
      $cfg['stats_first']     = $res['SETTINGS']['TMOS_IT'][0]['STATS_FIRST'][0];
      $cfg['recs']            = $res['SETTINGS']['TMOS_IT'][0]['RECS'][0];
      $cfg['recs_nf']         = $res['SETTINGS']['TMOS_IT'][0]['RECS_NF'][0];
      $cfg['recs_str']        = $res['SETTINGS']['TMOS_IT'][0]['RECS_STR'][0];
      $cfg['recs_player']     = $res['SETTINGS']['TMOS_IT'][0]['RECS_PLAYER'][0];
      $cfg['recs_player_str'] = $res['SETTINGS']['TMOS_IT'][0]['RECS_PLAYER_STR'][0];
      $cfg['recs_player_nf']  = $res['SETTINGS']['TMOS_IT'][0]['RECS_PLAYER_NF'][0];
      $cfg['teams']           = $res['SETTINGS']['TMOS_IT'][0]['TEAMS'][0];
      $cfg['teams_nf']        = $res['SETTINGS']['TMOS_IT'][0]['TEAMS_NF'][0];
      $cfg['teams_str']       = $res['SETTINGS']['TMOS_IT'][0]['TEAMS_STR'][0];
      $cfg['srv']             = $res['SETTINGS']['TMOS_IT'][0]['SRV'][0];
      $cfg['srv_tp']          = $res['SETTINGS']['TMOS_IT'][0]['SRV_TP'][0];
      $cfg['srv_tt']          = $res['SETTINGS']['TMOS_IT'][0]['SRV_TT'][0];
      $cfg['srv_ta']          = $res['SETTINGS']['TMOS_IT'][0]['SRV_TA'][0];
      $cfg['srv_tc']          = $res['SETTINGS']['TMOS_IT'][0]['SRV_TC'][0];
      $cfg['time']            = $res['SETTINGS']['TMOS_IT'][0]['TIME'][0];
      $cfg['err_disabled']    = $res['SETTINGS']['TMOS_IT'][0]['ERR_DISABLED'][0];
      $cfg['err_parameter']   = $res['SETTINGS']['TMOS_IT'][0]['ERR_PARAMETER'][0];
      $cfg['help']            = $res['SETTINGS']['TMOS_IT'][0]['HELP'][0];
      $cfg['help_c']          = $res['SETTINGS']['TMOS_IT'][0]['HELP_C'][0];
      $cfg['help_tt']         = $res['SETTINGS']['TMOS_IT'][0]['HELP_TT'][0];
      $cfg['help_top10']      = $res['SETTINGS']['TMOS_IT'][0]['HELP_TOP10'][0];
      $cfg['help_stats']      = $res['SETTINGS']['TMOS_IT'][0]['HELP_STATS'][0];
      $cfg['help_recs']       = $res['SETTINGS']['TMOS_IT'][0]['HELP_RECS'][0];
      $cfg['help_teams']      = $res['SETTINGS']['TMOS_IT'][0]['HELP_TEAMS'][0];
      $cfg['help_srv']        = $res['SETTINGS']['TMOS_IT'][0]['HELP_SRV'][0];
      $cfg['help_time']       = $res['SETTINGS']['TMOS_IT'][0]['HELP_TIME'][0];
      $cfg['help_curr']       = $res['SETTINGS']['TMOS_IT'][0]['HELP_CURR'][0];
   }
   $aseco->tmos = new TTMOS();
   $res = $aseco->tmos->init($cfg);

   $aseco->console_text("[TMOS] TM Offline Stats Plugin ...");
   $aseco->console_text("[TMOS] (c) 2007, Alexander Domnin (http://tmos.pp.ru)");
   $aseco->console_text("[TMOS] Load settings file: ".($res['cfg'] ? "Success" : "Fail"));
   $aseco->console_text("[TMOS] Try to connect to MySQL server: ".($res['db'] ? "Success" : "Fail"));
   $aseco->console_text("[TMOS] Check DB version (need v0.62): ".($res['schema'] ? "Success" : "Fail"));
   $aseco->console_text("[TMOS] Search server with ID {$cfg['dbserverid']}: ".($res['srv'] ? "Success" : "Fail"));
   $aseco->console_text("[TMOS] Plugin: ".($res['enable'] ? "Enabled" : "Disabled"));

   // reopen aseco connection for localdb plugin if needed
   global $ldb_settings;
   if (isset($ldb_settings)) {
      mysql_connect($ldb_settings['mysql']['host'], $ldb_settings['mysql']['login'], $ldb_settings['mysql']['password'], true);
      mysql_select_db($ldb_settings['mysql']['database']);
   }
}

function chat_tmos(&$aseco, &$command) {

   $command['params'] = preg_split("/\s/", $command['params'], 2, PREG_SPLIT_NO_EMPTY);

   $msg = "";
   if ($aseco->tmos->cfg['write_to_chat']) $msgtochat = true;
   else $msgtochat = false;
   if (!isset($command['params'][0])) $command['params'][0] = "error";
   if (isset($command['params'][1]) && $command['params'][1] == "c") {
      $stats = "c";
      $msg_stats = " *";
   }
   else {
      $stats = "a";
      $msg_stats = "";
   }
   $lu = $aseco->tmos->get_lu_time();

   if (!$aseco->tmos->inf['enable']) {
      $msgtochat = true;
      $msg = $aseco->formatColors($aseco->tmos->cfg['err_disabled']);
   }
   else if ($command['params'][0] == "help") {
      $msg = $aseco->formatColors($aseco->tmos->cfg['help'])."\n";
      $msg .= $aseco->formatColors($aseco->tmos->cfg['help_c'])."\n";
      $msg .= $aseco->formatColors($aseco->tmos->cfg['help_tt'])."\n";
      $msg .= $aseco->formatColors($aseco->tmos->cfg['help_top10'])."\n";
      $msg .= $aseco->formatColors($aseco->tmos->cfg['help_stats'])."\n";
      $msg .= $aseco->formatColors($aseco->tmos->cfg['help_recs'])."\n";
      $msg .= $aseco->formatColors($aseco->tmos->cfg['help_teams'])."\n";
      $msg .= $aseco->formatColors($aseco->tmos->cfg['help_srv'])."\n";
      $msg .= $aseco->formatColors($aseco->tmos->cfg['help_time'])."\n";
      $msg .= $aseco->formatColors($aseco->tmos->cfg['help_curr']);
   }
   else if ($command['params'][0] == "tt") {
      // data
      $data = $aseco->tmos->get_ptt_format($command['author']->login, $aseco->server->challenge->uid, $stats);
      // msg
      $msg = $aseco->formatColors(formatText($aseco->tmos->cfg['lu'], $lu, $msg_stats))."\n";
      $msg .= $aseco->formatColors(formatText($aseco->tmos->cfg['tt'], $aseco->server->challenge->name))."\n";
      $msg .= $aseco->formatColors(formatText($aseco->tmos->cfg['tt_author'], formatTime($aseco->server->challenge->authortime)))."\n";
      $msg .= $aseco->formatColors(formatText($aseco->tmos->cfg['tt_gold'], formatTime($aseco->server->challenge->goldtime)))."\n";
      $msg .= $aseco->formatColors(formatText($aseco->tmos->cfg['tt_silver'], formatTime($aseco->server->challenge->silvertime)))."\n";
      $msg .= $aseco->formatColors(formatText($aseco->tmos->cfg['tt_bronze'], formatTime($aseco->server->challenge->bronzetime)))."\n";
      if ($data === -1)
         $msg .= $aseco->formatColors(formatText($aseco->tmos->cfg['tt_player_nf'], $command['author']->nickname))."\n";
      else
         $msg .= $aseco->formatColors(formatText($aseco->tmos->cfg['tt_player_str'], $data['bestresult'], $data['player']))."\n";
   }
   else if ($command['params'][0] == "top10") {
      // data
      $data = $aseco->tmos->get_top10_format($command['author']->login, $stats);
      // msg
      $msg = $aseco->formatColors(formatText($aseco->tmos->cfg['lu'], $lu, $msg_stats))."\n";
      if ($data === -1) {
         $msg .= $aseco->formatColors($aseco->tmos->cfg['t10_nf'])."\n";
      }
      else {
         $msg .= $aseco->formatColors($aseco->tmos->cfg['t10'])."\n";
         for ($i = 0; $i < $data['count']; $i++) {
            $msg .= $aseco->formatColors(formatText($aseco->tmos->cfg['t10_str'], $data[$i]['rank'], $data[$i]['score'], $data[$i]['player']))."\n";
         }
         $msg .= $aseco->formatColors($aseco->tmos->cfg['t10_player'])."\n";
         if ($data['x'] === -1)
            $msg .= $aseco->formatColors(formatText($aseco->tmos->cfg['t10_player_nf'], $command['author']->nickname))."\n";
         else
            $msg .= $aseco->formatColors(formatText($aseco->tmos->cfg['t10_player_str'], $data['x']['rank'], $data['x']['score'], $data['x']['player']))."\n";
      }
   }
   else if ($command['params'][0] == "stats") {
      // data
      $data = $aseco->tmos->get_player_stats_format($command['author']->login, $stats);
      // msg
      $msg = $aseco->formatColors(formatText($aseco->tmos->cfg['lu'], $lu, $msg_stats))."\n";
      if ($data === -1) {
         $msg .= $aseco->formatColors(formatText($aseco->tmos->cfg['stats_nf'], $command['author']->nickname))."\n";
      }
      else {
         $msg .= $aseco->formatColors(formatText($aseco->tmos->cfg['stats'], $data['player']))."\n";
         $msg .= $aseco->formatColors(formatText($aseco->tmos->cfg['stats_rank'], $data['rank']))."\n";
         $msg .= $aseco->formatColors(formatText($aseco->tmos->cfg['stats_score'], $data['score']))."\n";
         $msg .= $aseco->formatColors(formatText($aseco->tmos->cfg['stats_medals'], $data['am'], $data['gm'], $data['sm'], $data['bm']))."\n";
         $msg .= $aseco->formatColors(formatText($aseco->tmos->cfg['stats_tf'], $data['tracksfinished']))."\n";
         $msg .= $aseco->formatColors(formatText($aseco->tmos->cfg['stats_first'], $data['first']))."\n";
      }
   }
   else if ($command['params'][0] == "recs") {
      // data
      $data = $aseco->tmos->get_recs_format($command['author']->login, $aseco->server->challenge->uid, $stats);
      // msg
      $msg = $aseco->formatColors(formatText($aseco->tmos->cfg['lu'], $lu, $msg_stats))."\n";
      if ($data === -1) {
         $msg .= $aseco->formatColors($aseco->tmos->cfg['recs_nf'])."\n";
      }
      else {
         $msg .= $aseco->formatColors(formatText($aseco->tmos->cfg['recs'], $aseco->server->challenge->name))."\n";
         for ($i = 0; $i < $data['count']; $i++) {
            $msg .= $aseco->formatColors(formatText($aseco->tmos->cfg['recs_str'], $data[$i]['rank'], $data[$i]['bestresult'], $data[$i]['player']))."\n";
         }
         $msg .= $aseco->formatColors($aseco->tmos->cfg['recs_player'])."\n";
         if ($data['x'] === -1)
            $msg .= $aseco->formatColors(formatText($aseco->tmos->cfg['recs_player_nf'], $command['author']->nickname))."\n";
         else
            $msg .= $aseco->formatColors(formatText($aseco->tmos->cfg['recs_player_str'], $data['x']['rank'], $data['x']['bestresult'], $data['x']['player']))."\n";
      }
   }
   else if ($command['params'][0] == "teams") {
      // data
      $data = $aseco->tmos->get_teams_format($stats);
      // msg
      $msg = $aseco->formatColors(formatText($aseco->tmos->cfg['lu'], $lu, $msg_stats))."\n";
      if ($data === -1) {
         $msg .= $aseco->formatColors($aseco->tmos->cfg['teams_nf'])."\n";
      }
      else {
         $msg .= $aseco->formatColors($aseco->tmos->cfg['teams'])."\n";
         for ($i = 0; $i < $data['count']; $i++) {
            $msg .= $aseco->formatColors(formatText($aseco->tmos->cfg['teams_str'], $data[$i]['rank'], $data[$i]['score'], $data[$i]['tm'], $data[$i]['clanc']))."\n";
         }
      }
   }
   else if ($command['params'][0] == "srv") {
      // data
      $data = $aseco->tmos->get_srv_stats_format($stats);
      // msg
      $msg = $aseco->formatColors(formatText($aseco->tmos->cfg['lu'], $lu, $msg_stats))."\n";
      $msg .= $aseco->formatColors(formatText($aseco->tmos->cfg['srv'], $data['server']))."\n";
      $msg .= $aseco->formatColors(formatText($aseco->tmos->cfg['srv_tp'], $data['totalplayers']))."\n";
      $msg .= $aseco->formatColors(formatText($aseco->tmos->cfg['srv_tt'], $data['totaltracks']))."\n";
      $msg .= $aseco->formatColors(formatText($aseco->tmos->cfg['srv_ta'], $data['totalawards']))."\n";
      $msg .= $aseco->formatColors(formatText($aseco->tmos->cfg['srv_tc'], $data['totalteams']))."\n";
   }
   else if ($command['params'][0] == "time") {
      $msgtochat = true;
      $data = $aseco->tmos->get_time();
      $msg = $aseco->formatColors(formatText($aseco->tmos->cfg['time'], $data));
   }
   else {
      $msgtochat = true;
      $msg = $aseco->formatColors($aseco->tmos->cfg['err_parameter']);
   }
   // send
   if ($aseco->server->getGame() != "TMN" || $msgtochat)
      $aseco->addCall("ChatSendServerMessageToLogin", array($msg, $command['author']->login));
   else
      $aseco->addCall("SendDisplayServerMessageToId", array($command['author']->id, $msg, "OK", "", 0));
}

?>